﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
	
#End Region

'	Sub Process_Globals is the place to declare the service global variables. 
'	There is no other Globals sub like in Activity as Service doesn't support Activity objects.
'	Sub process globals should only be used To declare variables. It should Not run any other code As it might fail. 
'	This Is True For other modules As well. Note that Process_Global variables are kept As Long As the process runs And are accessible from other modules.
Sub Process_Globals
		
	'GPS
'	Public GPS1 As GPS
'	Public rp As RuntimePermissions


	' System
	'Public PhoneWake As PhoneWakeState
	Private nid As Int = 1
	Private lock As PhoneWakeState
	Dim notification As Notification
	
	Dim Location2 As Location
	Dim LockedPoint As Boolean
	Dim InTime As String
	Dim OutTime As String
	Dim LockedIndex As Int
	Dim lMap As Map
	Dim Location3 As Location
	Dim StopDistance, xProducts As Int
End Sub


'	Sub Service_Create is called when the service is first started. 
'	This is the place to initialize and set the process global variables. 
'	Once a service is started it stays alive until you call StopService or until the whole process is destroyed.
Sub Service_Create
	Log("GPSservice.Service_Create")
'	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_WHEN_NEEDED
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
	lock.PartialLock
	

'	GPS1.Initialize("GPS")
End Sub

'	Sub Service_Start is called each time you call StartService (or StartServiceAt). 
'	When this subs runs the process is moved to the foreground state. 
'	Which means that the OS will not kill your process until this sub finishes running. 
'	If you want to run some code every couple of minutes / hours you should schedule the next task with StartServiceAt inside this sub.
Sub Service_Start (StartingIntent As Intent)
	
	If StartingIntent.HasExtra("android.intent.extra.ALARM_COUNT") Then
		' The scheduled service was started
		' Check GPS
		Log("GPSservice.ServiceStart, StartingIntet.HasExtra(...")
		
		End If
	Service.StartForeground(nid, CreateNotification("Loading..."))
	Starter.InBackground = True
	'GPS
	StartGps
	
'	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
	
	' Autostart of service in 'Timer'
	Dim Timer As Long = DateTime.Now + 20 * DateTime.TicksPerSecond
	Log("GPSservice.Service_Start -" & DateTime.Time(Timer))

	'CallSubDelayed(Starter, "StartGPS")
	If Starter.InBackground Then
		StartServiceAt(Me, Timer, True)
	End If
End Sub

'	Sub Service_Destroy is called when you call StopService. 
'	The service will not be running after this sub until you call StartService again 
'	(which will run Sub Service_Create followed by Sub Service_Start).
Sub Service_Destroy
	Log("GPSservice.Service_Destroy")
'	If Starter.gpsStarted Then StopGps
	Starter.GPS1.Stop
	Starter.InBackground = False
	Starter.gpsStarted = False
	Service.StopAutomaticForeground
	Service.StopForeground(1)
	CancelScheduledService(Me)
End Sub

'Sub GPSserviceDestroy
'	Log("GPSservice.Service_Destroy")
''	If Starter.gpsStarted Then StopGps
'	Starter.GPS1.Stop
'	Starter.InBackground = False
'	Starter.gpsStarted = False
'	Service.StopAutomaticForeground
'	CancelScheduledService(Me)
'End Sub

Public Sub StartGps
	If Starter.KeepGPSoff = False Then
		Log("GPSservice, GPSstart")
		Starter.GPS1.Start(4000, 1)  ' Last time = 400            'Starter.GPSinterval, 1)
		Starter.gpsStarted = True
	End If
End Sub

Public Sub StopGps
	If Starter.gpsStarted Then
		Log("GPSservice, GPSstop")
		Starter.GPS1.Stop
		Starter.gpsStarted = False
		'ActivePart=""
	End If
	Service.StopAutomaticForeground
End Sub

Public Sub GPS_LocationChanged (Location1 As Location)
	
	Log(Location1)
	

End Sub


Sub CreateNotification (Body As String) As Notification
'	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_LOW)
	notification.Icon = "whtrc36"
	notification.Sound = False
	notification.Vibrate = False
	notification.SetInfo("SL Claims", Body, Main)
	
	Return notification
End Sub

Public Sub ChangeNotification
	Dim n As Notification = CreateNotification($"$2.5{Starter.GPSlat} / $2.5{Starter.GPSlon}"$)
	n.Notify(1)
End Sub