﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	'Misc
	Public ActivePart As String			'Which activity is active for GPS; "Nearby", ....
	
	'GPS
	Public GPS1 As GPS
	Public GPSinterval As Long
	Public GPSlat As Double 'Long
	Public GPSlon As Double 'Long
	Public GPSlatLast As Double
	Public GPSlonLast As Double
	Public GPStime As Long
	Public gpsStarted As Boolean
	Public KeepGPSoff As Boolean = False
	Public InBackground As Boolean
	
	' List of points during tracking
	Public Point As Map
	Public PointCollection As Map
	Public PassedPoint As Map
	Public PassedPointCollection As Map
	Public PassedIndex As Map
	Public FollowActive As Boolean = False
	Public TestOK As Boolean = False
	
	Public FollowChanged As Boolean
	
	'HTTPservice, from different SL api
	'-
	' Get Nearby points V2
	Public NearbyMap As Map
	Public NearbyContentMap As Map
	' GetRealtimeDepartures v4
	Public RTDmetro As Map
	Public RTDmetroDetails As Map
	Public RTDmetroDev As Map
	Public RTDbus As Map
	Public RTDbusDetails As Map
	Public RTDbusDev As Map
	Public RTDtrain As Map
	Public RTDtrainDetails As Map
	Public RTDtrainDev As Map
	Public RTDtram As Map
	Public RTDtramDetails As Map
	Public RTDtramDev As Map
	Public RTDship As Map
	Public RTDshipDetails As Map
	Public RTDshipDev As Map
	Public RTDall As Map
	Public TripResult As Map
	Public TripDetail As Map
	
	'System
	Public rp As RuntimePermissions
	Public xNotIcon As Bitmap
	Public xNot As NB6
	
	' Classes
'	Public apiHTTPs As apiHTTP
	
	' Platsuppslag
	Public PlatsuppslagSuggestions As Map
	Public PlatsuppslagSuggestionsOK As Boolean
	
	Public WhichButton As String
	Public NearbyStopsReady As Boolean
	Public GetSiteIDReady As Boolean
	Public GetRealtimeDeparturesReady As Boolean
	Public ReseplanerareTripReady As Boolean
	
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	
	Log("-----------------------------------------------------------------------------------")
	Log("-")
	Log("-  Start.  Time: " & DateTime.Time(DateTime.Now))
	Log("-")
	Log("-----------------------------------------------------------------------------------")
	
	GPSinterval = 400	'Sätt intervallet. kortare i front, längre in background
	GPS1.Initialize("GPS")
	
	'Init things for the app
	NearbyMap.Initialize
	NearbyContentMap.Initialize
	RTDmetro.Initialize
	RTDmetroDetails.Initialize
	RTDmetroDev.Initialize
	RTDbus.Initialize
	RTDbusDetails.Initialize
	RTDbusDev.Initialize
	RTDtrain.Initialize
	RTDtrainDetails.Initialize
	RTDtrainDev.Initialize
	RTDtram.Initialize
	RTDtramDetails.Initialize
	RTDtramDev.Initialize
	RTDship.Initialize
	RTDshipDetails.Initialize
	RTDshipDev.Initialize
	TripResult.Initialize
	TripDetail.Initialize
	RTDall.Initialize
	
	'Tracker
	Point.Initialize					'Each single point; Lat, Lon, Index, Tripnbr, Name, time
	PointCollection.Initialize			'All collected points above
	PassedPoint.Initialize
	PassedPointCollection.Initialize
	PassedIndex.Initialize
	
	' Classes init
'	apiHTTPs.Initialize
	

End Sub

Sub Service_Start (StartingIntent As Intent)
	Log("Starter.Service_Start")
	'Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
	Log("Service destroyed")
'	lock.ReleasePartialLock
	Service.StopAutomaticForeground
	Service.StopForeground(1)
	GPS1.Stop
	CancelScheduledService(GPSservice)
	CancelScheduledService(Me)
End Sub
